#!/bin/bash

source xsc_common_irq_affinity.sh

devices=$(ls /sys/class/net/)
for device in $devices
do
	n=0
	xscdev=$(ethtool -i $device | grep "xsc_eth")
	if [ ! -z "$xscdev" ]
	then
		busid=$(ethtool -i $device | grep "bus-info" | awk -F " " '{print $2}')
		irqs=$(cat /proc/interrupts | grep $busid | awk -F ":" '{print $1}')
		for irq in $irqs
 		do
			coreid=$(cat /proc/irq/$irq/effective_affinity_list)
			coreids[$n]=$coreid
			n=$(($n+1))
		done
		device_node=$(cat /sys/class/net/$device/device/numa_node)
		node_cpus=$(lscpu | grep "NUMA node$device_node" | awk -F ":" '{print $2}')
		#echo "device $device core ${coreids[@]}"
		range_format=$(echo $node_cpus | grep "-")
		if [ -z $range_format ]
		then
			for id in $coreids
			do
				innode=$(echo $node_cpus | grep -w $id)
				if [ -z $innode ]
				then
					echo "error affinity setting"
					echo "$device numa_node $device_node cpu $node_cpus"
					echo "$device intr error cpu $id"
					exit
				fi
			done
		else
			cpu_range1=$(echo $node_cpus | awk -F "," '{print $1}')
			cpu_range2=$(echo $node_cpus | awk -F "," '{print $2}')
			checkids=(${coreids[@]})
			while [ ! -z "$cpu_range1" ]
			do
				start_id=$(echo $cpu_range1 | awk -F "-" '{print $1}')
				end_id=$(echo $cpu_range1 | awk -F "-" '{print $2}')
				for id in ${!checkids[@]}
	        	        do
					if [[ ${checkids[$id]} -ge $start_id ]] &&
						[[ ${checkids[$id]} -le $end_id ]]
					then
						unset checkids[$id]
					fi
	                	done
				cpu_range1=$(echo $cpu_range2 | awk -F "," '{print $1}')
				cpu_range2=$(echo $cpu_range2 | awk -F "," '{print $2}')
			done
			checkres=$(echo ${#checkids[@]})
			if [[ "$checkres" -gt "0" ]]
			then
				echo "error affinity setting"
				echo "$device numa_node $device_node cpu $node_cpus"
				echo "err $device core ${checkids[@]}"
				exit
			fi
		fi
		echo "$device check pass"
		echo "$device numa_node $device_node cpu $node_cpus"
		echo "$device current cores ${coreids[@]}"
		echo "===================================================="
        fi
done

