#!/bin/bash

if [ -z $1 ]
then
    echo "usage: bash xsc_nic_rename <pf/vf/pfvf>"
    exit
fi

pf_rename=`echo $1 | grep "pf"`
vf_rename=`echo $1 | grep "vf"`

if [ $vf_rename ]
then
    rm -f /etc/udev/rules.d/70-xsc-vf-net-names.rules
    echo 'ACTION=="add", SUBSYSTEM=="net", DRIVERS=="xsc*", ATTR{phys_port_name}!="",NAME="$attr{phys_port_name}"' \
                        > /etc/udev/rules.d/70-xsc-vf-net-names.rules
fi

if [ $pf_rename ]
then
    PCI_PATH="/sys/bus/pci/devices"
    SLOT_PATH="/sys/bus/pci/slots"
    xscbusids=`ls $PCI_PATH`
    for xscbusid in $xscbusids
    do
        vendor_id=`cat $PCI_PATH/$xscbusid/vendor`
        xsc_id=`echo $vendor_id | grep "1f67"`
        pf_dev_id=`cat $PCI_PATH/$xscbusid/device | grep "0x1011\|0x1111"`
        if [[ ! -z $xsc_id ]] && [[ ! -z $pf_dev_id ]]
        then
            pf_id=`echo $xscbusid | awk -F '.' '{print $2}'`
            dev_path=`udevadm info -q property -p $PCI_PATH/$xscbusid/net/* | grep "DEVPATH"`
            dirname1=`echo $dev_path | cut -f 4 -d '/' | cut -f 1 -d '.'`
            dirname2=`echo $dev_path | cut -f 5 -d '/' | cut -f 1 -d '.'`
            slots=`ls $SLOT_PATH`
            for slot in $slots
            do
                slot_addr1=`cat $SLOT_PATH/$slot/address | grep $dirname1`
                if [ ! -z $slot_addr1 ]
                then
                    nic_name="xscs${slot}p${pf_id}"
                    echo 'ACTION=="add", SUBSYSTEM=="net", DRIVERS=="xsc*",\
				KERNELS=="'$xscbusid'",NAME="'$nic_name'"' \
                                >> /etc/udev/rules.d/70-xsc-pf-net-names.rules
                    break
                fi
                slot_addr2=`cat $SLOT_PATH/$slot/address | grep $dirname2`
                if [ ! -z $slot_addr2 ]
                then
                    nic_name="xscs${slot}p${pf_id}"
                    echo 'ACTION=="add", SUBSYSTEM=="net", DRIVERS=="xsc*",\
				KERNELS=="'$xscbusid'",NAME="'$nic_name'"' \
                                >> /etc/udev/rules.d/70-xsc-pf-net-names.rules
                fi
            done
        fi
    done
fi

echo "set rename rule done"
