#!/bin/bash

source xsc_common_irq_affinity.sh

nodes=$(lscpu | grep "NUMA node(s)" | cut -d ":" -f 2 | sed 's/ //g')
devices=$(ls /sys/class/net/)
for device in $devices
do
	xscflag=$(ethtool -i $device | grep "xsc_eth")
	if [ ! -z "$xscflag" ]
	then
		node=$(cat /sys/class/net/$device/device/numa_node)
		xscdevs=$xscdevs" "$device
		bash xsc_set_rps_bynode.sh $node $device
	fi
done

i=0
while [ $i -lt $nodes ]
do
	for xdev in $xscdevs
	do
		dev_node=$(cat /sys/class/net/$xdev/device/numa_node)
		if [[ $dev_node -eq $i ]]
		then
			node_dev=$node_dev" "$xdev
		fi
	done
	if [ -z "$node_dev" ]
	then
		i=$(($i+1))
		continue
	fi
	bash xsc_set_irq_affinity_bynode.sh $i $node_dev
	i=$(($i+1))
	node_dev=""
done
