#!/bin/bash

if [ -z $2 ]; then
	echo "usage: bash $0 <node id> <interface1> [interface2]"
	exit 1
fi

source xsc_common_irq_affinity.sh

node=$1
interface=$2
interface2=$3

cpulist=$(cat /sys/devices/system/node/node$node/cpulist )
if [ "$(echo $?)" != "0" ]; then
	echo "Node id '$node' does not exists."
	exit
fi

cpu_range1=$(echo $cpulist | awk -F "," '{print $1}')
cpu_range2=$(echo $cpulist | awk -F "," '{print $2}')

while [ ! -z "$cpu_range1" ]
do
	for word in $(seq 1 $CORES)
	do
		SEQ=$(echo $cpu_range1 | cut -d "," -f $word | sed 's/-/ /')
		if [ "$(echo $SEQ | wc -w)" != "1" ]; then
			CPULIST="$CPULIST $( echo $(seq $SEQ) | sed 's/ /,/g' )"
		fi
	done
	cpu_range1=$(echo $cpu_range2 | awk -F "," '{print $1}')
	cpu_range2=$(echo $cpu_range2 | awk -F "," '{print $2}')
done

if [ "$CPULIST" != "" ]; then
	cpulist=$(echo $CPULIST | sed 's/ /,/g')
fi
CORES=$( echo $cpulist | sed 's/,/ /g' | wc -w )

echo "cpulist" $cpulist

rpsqueues=$(ls /sys/class/net/$interface/queues/ | grep "rx")

if [ $interface2 ]; then
	rpsqueues_2=$(ls /sys/class/net/$interface2/queues/ | grep "rx")
fi

qnum=$(ls /sys/class/net/$interface/queues/ | grep "rx" | wc -l)

I=1
for rpsqueue in $rpsqueues
do
	rpsdir=$(ls /sys/class/net/$interface/queues/$rpsqueue/rps_cpus)
	if [ ! -f $rpsdir ]; then
		echo "error $interface queues list $rpsdir"
		continue
	fi
	core_id=$(echo $cpulist | cut -d "," -f $I)
	affinity=$( core_to_affinity $core_id )
	echo $affinity > $rpsdir
	echo "$rpsdir is set to core $core_id affinity $affinity"
	if [ -z $interface2 ]; then
		I=$(( (I%CORES) + 1 ))
	else
		I=$(( (I%(CORES/2)) + 1 ))
	fi
done

echo ""
echo "==================================================================="
echo ""

qnum=$(ls /sys/class/net/$interface/queues/ | grep "rx" | wc -l)

I=$(( (CORES/2) + 1 ))
for rpsqueue_2 in $rpsqueues_2
do
        rpsdir_2=$(ls /sys/class/net/$interface2/queues/$rpsqueue_2/rps_cpus)
        if [ ! -f $rpsdir_2 ]; then
                echo "error $interface2 queues list $rpsdir_2"
                continue
        fi
        core_id=$(echo $cpulist | cut -d "," -f $I)
        affinity=$( core_to_affinity $core_id )
        echo $affinity > $rpsdir_2
	echo "$rpsdir is set to core $core_id affinity $affinity"
	I=$(( (I%(CORES/2)) + 1 + (CORES/2) ))
done
